From 456f6413f77cb8ea8a135d457a3839cb36c90277 Mon Sep 17 00:00:00 2001
From: "henrique.garcia" <henrique.garcia@toradex.com>
Date: Thu, 13 Apr 2023 16:17:01 -0300
Subject: [PATCH] Add DRAM PLL for 1866MHz and enable SSCG

---
 plat/imx/imx8m/ddr/clock.c | 8 ++++++++
 1 file changed, 8 insertions(+)

diff --git a/plat/imx/imx8m/ddr/clock.c b/plat/imx/imx8m/ddr/clock.c
index 7eb989f9..0f7ec586 100644
--- a/plat/imx/imx8m/ddr/clock.c
+++ b/plat/imx/imx8m/ddr/clock.c
@@ -58,6 +58,14 @@ void dram_pll_init(unsigned int drate)
 	mmio_setbits_32(HW_DRAM_PLL_CFG0, 0x30);
 
 	switch (drate) {
+	case 4000:
+		mmio_write_32(DRAM_PLL_CTRL + 0x5C, 0x800043C1);	/* enable SSCG */
+ 		mmio_write_32(DRAM_PLL_CTRL + 0x4, (250 << 12) | (3 << 4) | 1);
+ 		break;
+	case 3732:
+		mmio_write_32(DRAM_PLL_CTRL + 0x5C, 0x80004321);	/* enable SSCG */
+		mmio_write_32(DRAM_PLL_CTRL + 0x4, (311 << 12) | (4 << 4) | 1);
+		break;
 	case 3200:
 		mmio_write_32(HW_DRAM_PLL_CFG2, 0x00ece580);
 		break;
-- 
2.34.1

